Subject: Re: bug#57306: guix pull to old commit fails due to unsupported manifest format

From: zimoun <[email-masked]>
Date: Mon, 29 Aug 2022 16:59:36 +0200

Hi Arun,

On sam., 20 août 2022 at 15:07, Arun Isaac <[email-masked]> wrote:
> When I guix pull to 6f75565b4ec3b8a7247699c327a3b3196c787f76, activate
> the profile and run guix describe, it fails with an "unsupported
> manifest format" error.
>
> --8<---------------cut here---------------start------------->8---
> $ guix pull --commit=6f75565b4ec3b8a7247699c327a3b3196c787f76 -p
> /tmp/test
> $ source /tmp/test/etc/profile
> $ guix describe
> guix describe: error: unsupported manifest format
> --8<---------------cut here---------------end--------------->8---
>
> This happens because my guix-daemon writes a version 4 manifest and the
> guix from commit 6f75565b4ec3b8a7247699c327a3b3196c787f76 only
> understands a version 3 manifest.

I do not think it is related to guix-daemon and I think it is expected;
indeed it could be considered as a bug.  The command-line,

    guix pull --commit=xyz -p /tmp/test

writes /tmp/test/manifest using the current Guix (say manifest 4) and
not using Guix at commit xyz (say manifest 3).  Contrary to “guix
time-machine --commit=xyz”.

--8<---------------cut here---------------start------------->8---
$ cat ~/.cache/guix/inferiors/cfcv5rt7xiax6pvdqwoad3hdrsqrpl34z2tufvtcb7nspeum5cba/manifest
;; This file was automatically generated and is for internal use only.
;; It cannot be passed to the '--manifest' option.
;; Run 'guix package --export-manifest' if you want to export a file
;; suitable for '--manifest'.

(manifest
  (version 3)
  (packages
    (("guix"
      "6f75565"
      "out"
      "/gnu/store/3nfgbg6nd6vq9im8fp97h6h5zm1rvhzh-guix-6f75565b4"
      (propagated-inputs ())
      (search-paths ())
      (properties
        (source
          (repository
            (version 0)
            (url "https://git.savannah.gnu.org/git/guix.git")
            (branch #f)
            (commit
              "6f75565b4ec3b8a7247699c327a3b3196c787f76")
            (name guix)
            (introduction
              (channel-introduction
                (version 0)
                (commit
                  "9edb3f66fd807b096b48283debdcddccfea34bad")
                (signer
                  "BBB0 2DDF 2CEA F6A8 0D1D  E643 A2A0 6DF2 A33A 54FA"))))))))))
--8<---------------cut here---------------end--------------->8---

Cheers,
simon